/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the CheckProgress200Response type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &CheckProgress200Response{}

// CheckProgress200Response struct for CheckProgress200Response
type CheckProgress200Response struct {
	Progress *int32 `json:"progress,omitempty"`
	Total *int32 `json:"total,omitempty"`
}

// NewCheckProgress200Response instantiates a new CheckProgress200Response object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCheckProgress200Response() *CheckProgress200Response {
	this := CheckProgress200Response{}
	return &this
}

// NewCheckProgress200ResponseWithDefaults instantiates a new CheckProgress200Response object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCheckProgress200ResponseWithDefaults() *CheckProgress200Response {
	this := CheckProgress200Response{}
	return &this
}

// GetProgress returns the Progress field value if set, zero value otherwise.
func (o *CheckProgress200Response) GetProgress() int32 {
	if o == nil || IsNil(o.Progress) {
		var ret int32
		return ret
	}
	return *o.Progress
}

// GetProgressOk returns a tuple with the Progress field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CheckProgress200Response) GetProgressOk() (*int32, bool) {
	if o == nil || IsNil(o.Progress) {
		return nil, false
	}
	return o.Progress, true
}

// HasProgress returns a boolean if a field has been set.
func (o *CheckProgress200Response) HasProgress() bool {
	if o != nil && !IsNil(o.Progress) {
		return true
	}

	return false
}

// SetProgress gets a reference to the given int32 and assigns it to the Progress field.
func (o *CheckProgress200Response) SetProgress(v int32) {
	o.Progress = &v
}

// GetTotal returns the Total field value if set, zero value otherwise.
func (o *CheckProgress200Response) GetTotal() int32 {
	if o == nil || IsNil(o.Total) {
		var ret int32
		return ret
	}
	return *o.Total
}

// GetTotalOk returns a tuple with the Total field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CheckProgress200Response) GetTotalOk() (*int32, bool) {
	if o == nil || IsNil(o.Total) {
		return nil, false
	}
	return o.Total, true
}

// HasTotal returns a boolean if a field has been set.
func (o *CheckProgress200Response) HasTotal() bool {
	if o != nil && !IsNil(o.Total) {
		return true
	}

	return false
}

// SetTotal gets a reference to the given int32 and assigns it to the Total field.
func (o *CheckProgress200Response) SetTotal(v int32) {
	o.Total = &v
}

func (o CheckProgress200Response) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o CheckProgress200Response) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Progress) {
		toSerialize["progress"] = o.Progress
	}
	if !IsNil(o.Total) {
		toSerialize["total"] = o.Total
	}
	return toSerialize, nil
}

type NullableCheckProgress200Response struct {
	value *CheckProgress200Response
	isSet bool
}

func (v NullableCheckProgress200Response) Get() *CheckProgress200Response {
	return v.value
}

func (v *NullableCheckProgress200Response) Set(val *CheckProgress200Response) {
	v.value = val
	v.isSet = true
}

func (v NullableCheckProgress200Response) IsSet() bool {
	return v.isSet
}

func (v *NullableCheckProgress200Response) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCheckProgress200Response(val *CheckProgress200Response) *NullableCheckProgress200Response {
	return &NullableCheckProgress200Response{value: val, isSet: true}
}

func (v NullableCheckProgress200Response) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCheckProgress200Response) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


